﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace _3SortText
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        int sum = 0;
        string text;
        byte[] richText = null;
        void newbyte(int i)
        {
            richText = null;
            richText = new byte[i];
        }
        private void открытьToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            OpenFileDialog ofDlg = new OpenFileDialog();
            ofDlg.Filter = "Текстовые Файлы (*.txt;)|*.txt|All files (*.*)|*.*";
            if (ofDlg.ShowDialog() == DialogResult.OK)
                try
                { 
                  richTextBox1.LoadFile(ofDlg.FileName, RichTextBoxStreamType.PlainText); 
                  FileStream fs = new FileStream(ofDlg.FileName, FileMode.Open, FileAccess.Read);
                  BinaryReader TestFile = new BinaryReader(fs);
                  sum = Convert.ToInt16(fs.Length);
                  newbyte(sum);
                  TestFile.Read(richText, 0, sum);
                }
                catch
                { MessageBox.Show("Ой", "АйЙЙ!", MessageBoxButtons.OK, MessageBoxIcon.Information); }
        }
        private void сохранитьКакToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog of = new SaveFileDialog();
            of.Filter = "txt files (*.txt)|*.txt";
            if (of.ShowDialog() == System.Windows.Forms.DialogResult.OK & of.FileName.Length > 0)
            { richTextBox1.SaveFile(of.FileName, RichTextBoxStreamType.PlainText); }
        }
        private void алфавитToolStripMenuItem_Click(object sender, EventArgs e)
        {
            byte[] АлфавитByte = new byte[255];
            string[] Алфавит = new string[255];
            for (byte  i = 0; i < 255; i++)
            {
                Алфавит[i] = Convert.ToChar(i+1).ToString();
                АлфавитByte[i] = Convert.ToByte( i + 1);
            }
            text = string.Join("", Алфавит );
            richTextBox1.Text = text ;
            System.Text.Encoding ASCIIConverter;
            ASCIIConverter = System.Text.Encoding.GetEncoding("windows-1248");
            string ss = ASCIIConverter.GetString(АлфавитByte);
            richTextBox1.Text += ss;
        }
        private void разделитьToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sum = richText.Length;
            byte[] b = new byte[sum * 2]; int y = 0;
            for (int i = 0; i < richText.Length - 1; i++)
            {
                if (y > 0)
                {
                    if (richText[i] == 32 & b[y - 1] != 10)
                    {
                        b[y] = 13; b[y + 1] = 10; y += 2;
                        if (richText[i - 1] == 32)
                        { y -= 2; }
                    }
                    if (richText[i] == 13 & b[y - 1] != 10)
                    { b[y] = 13; b[y + 1] = 10; y += 2; i += 1; }
                }
                if (richText[i] > 64 & richText[i] < 91)
                { b[y] = richText[i]; y += 1; }
                if (richText[i] > 96 & richText[i] < 123)
                { b[y] = richText[i]; y += 1; }
                if (richText[i] == 168)
                { b[y] = richText[i]; y += 1; }
                if (richText[i] == 184)
                { b[y] = richText[i]; y += 1; }
                if (richText[i] > 191)
                { b[y] = richText[i]; y += 1; }
            }
            sum = y - 1;
            newbyte(sum);
            Array.Copy(b, richText, sum);
            System.Text.Encoding ASCIIConverter;
            ASCIIConverter = System.Text.Encoding.GetEncoding(1251);
            string ss = ASCIIConverter.GetString(richText);
            richTextBox1.Text = ss;
        }
        private void сортироватьToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (sum > 0)
            {
                string obmen;
                char p13 = Convert.ToChar(13); char p10 = Convert.ToChar(10);
                string p1310 = p13.ToString() + p10.ToString();
                System.Text.Encoding ASCIIConverter;
                ASCIIConverter = System.Text.Encoding.GetEncoding(1251);
                string ss = ASCIIConverter.GetString(richText);
                string[] sort = ss.Split(p13);
                sum = sort.Length;
                for (int i = 1; i < sum - 1; i++)
                { sort[i] = sort[i].Substring(1); }
                for (int i = 1; i < sum - 1; i++)
                {
                    if (sort[i].CompareTo(sort[i - 1]) < 0)
                    {
                        for (int y = i; y != 0; y--)
                        {
                            if (sort[y].CompareTo(sort[y - 1]) < 0)
                            { obmen = sort[y]; sort[y] = sort[y - 1]; sort[y - 1] = obmen; }
                        }
                    }
                }
                ss = string.Join(p1310, sort);
                richTextBox1.Text = ss;
            }
        }
    }
}
